100 REMark TKEDIT - Small configurator for Turbo Toolkit
110 :
120 fnm$ = IP_Filename$
130 IF Completed_Dialogue(fnm$) : Patch_Toolkit(fnm$)
140 STOP
150 :
160 DEFine FuNction IP_Filename$
170 LOCal lp, ok, fnm$(30)
180   MODE 0 : WINDOW 512,256,0,0 : PAPER 0 : INK 4 : CLS
190   PRINT '  Turbo Toolkit configuration'
200   PRINT ,,,,'.....   Only to be used for Turbo v'; : INK 7
210   PRINT '2.04'; : INK 4 : PRINT ' or later'
220   REPeat lp
230     AT 4,4
240     PRINT   'Enter device & name of toolkit file: ';
250     INK 7 : fnm$ = EDIT$('flp1_TURBO_TK_CODE', 35) : INK 4
260     ok = DEVICE_STATUS(fnm$)
270     IF ok = -8 : CLS 2 : EXIT lp
280     PRINT \\'   File not available, or write-protected'
290     END REPeat lp
300   RETurn fnm$
310   END DEFine 
320 :
330 DEFine FuNction Completed_Dialogue(fnm$)
340 LOCal lp
350   OPEN_IN #3,fnm$ : SET_POSITION #3,999999 : fil_len = POSITION(#3) : CLOSE #3
360   base = ALLOCATION(fil_len)
370   IF base < 0 : PRINT \\'    Insufficient memory to load file' : RETurn 0
380   LBYTES fnm$, base
390   patch = SEARCH_MEMORY(base, fil_len, 'INTER-COM')
400   IF patch = 0 : PRINT \\'    Not a Toolkit file of the right vintage' : RETurn 0
410   patch = patch+9
420   REPeat lp
430     REPeat inner
440       AT 6,0
450       PRINT '                         Default device: '; : CLS 4
460       INK 7 : dvc$ = EDIT$(PEEK$(patch,5),6) : INK 4
470       IF LEN(dvc$) = 5 : EXIT inner
480       END REPeat inner
490     PRINT \'                 Beep on error in EDIT$: '; : CLS 4
500     INK 7 : ed_beep = EDIT$("ny"(PEEK(patch+5)+1),2) == 'y' : INK 4
510     PRINT '         Default length of EDIT$ buffer: '; : CLS 4
520     INK 7 : ed_len = EDIT%(PEEK_W(patch+8),4) : INK 4
530     REPeat inner
540       AT 11,0
550       PRINT '  Abort key combination:'
560       PRINT '                In combination with ALT: '; : CLS 4
570       INK 7 : abt_alt = (EDIT$('ny'((PEEK(patch+7)=255)+1),2) == 'y')*255 : INK 4
580       PRINT '         ASCII value of abort character: '; : CLS 4
590       INK 7 : abt_ch  = EDIT%(PEEK(patch+6),4) : INK 4
600       IF abt_ch >=1 AND abt_ch <= 254 : EXIT inner
610       END REPeat inner
620     REPeat inner
630       AT 15,0
640       PRINT '              Default "pipe" definition: '; : CLS 4
650       INK 7 : pipe_def$ = EDIT$(PEEK$(patch+12,PEEK_W(patch+10)), 12) : INK 4
660       IF LEN(pipe_def$) = 10 : EXIT inner
670       END REPeat inner
680     PRINT \ '                    Are these values OK: '; : CLS 4
690     INK 7 : yn$ = EDIT$('y',2) : INK 4
700     IF yn$ == 'y' : EXIT lp
710     END REPeat lp
720   POKE$  patch,    dvc$
730   POKE   patch+5,  ed_beep
740   POKE_W patch+8,  ed_len
750   POKE   patch+6,  abt_ch
760   POKE   patch+7,  abt_alt
770   POKE_W patch+10, LEN(pipe_def$)
780   POKE$  patch+12, pipe_def$
790   RETurn 1
800   END DEFine 
810 :
820 DEFine PROCedure Patch_Toolkit(fnm$)
830   DELETE fnm$
840   SBYTES fnm$,base,fil_len
850   PRINT \\'End of task - patch completed'
860   END DEFine 
